#INCLUDE "APWIZARD.CH"
#INCLUDE "PROTHEUS.CH"
#INCLUDE "RWMAKE.CH"
#INCLUDE "TOPCONN.CH"

/*/


ͻ
Programa  VOKA0900   Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Biblioteca de funcoes .  		                          
͹
Uso        VOKO                                                       
ͼ




ͻ
Programa  VK0900FJ   Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Verifica se cliente e fisico ou juridico                   
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900FJ()
Local _cFJ := "01"

If SA1->A1_PESSOA == "J"
	_cFJ := "02"
Else
	_cFJ := "01"
EndIf

Return(_cFJ)

/*/


ͻ
Programa  VK0900End  Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Retorna endereco do endereco de cobranca.                  
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900End()
Local _cEnd := Space(40)

If !Empty(SA1->A1_ENDCOB)
	_cEnd := Substr(SA1->A1_ENDCOB,1,40)
Else
	_cEnd := Substr(SA1->A1_END,1,40)
EndIf

Return(_cEnd)

/*/


ͻ
Programa  VK0900BAI  Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Retorna bairro do endereco de cobranca.                    
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900BAI()
Local _cBairro := Space(12)

If !Empty(SA1->A1_BAICOB)
	_cBairro := Substr(SA1->A1_BAICOB,1,12)
Else
	_cBairro := Substr(SA1->A1_BAIRRO,1,12)
EndIf

Return(_cBairro)

/*/


ͻ
Programa  VK0900MUN  Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Retorna municipio do endereco de cobranca.                 
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900MUN()
Local _cMun := Space(15)

If !Empty(SA1->A1_MUNCOB)
	_cMun := Substr(SA1->A1_MUNCOB,1,15)
Else
	_cMun := Substr(SA1->A1_MUN,1,15)
EndIf

Return(_cMun)

/*/


ͻ
Programa  VK0900UF   Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Retorna unidade federativa do endereco de cobranca.        
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900UF()
Local _cUF := Space(02)

If !Empty(SA1->A1_ESTCOB)
	_cUF := SA1->A1_ESTCOB
Else
	_cUF := SA1->A1_EST
EndIf

Return(_cUF)

/*/


ͻ
Programa  VK0900CEP  Autor Marcelo Brigagao     Data   26/10/10   
͹
Descricao  Retorna CEP                                                
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900CEP()
Local _cCEP := " "

If !Empty(SA1->A1_CEPCOB)
	_cCEP := SA1->A1_CEPCOB
Else
	_cCEP := SA1->A1_CEP
EndIf

Return(_cCEP)

/*/


ͻ
Programa  VK0900MSG  Autor Marcelo Brigagao     Data   03/11/10   
͹
Descricao  Retorna MSG para impressao no boleto                       
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900MSG()
Local _cMSG := Space(60)

_cMSG := "Ref. nossa NF numero:"+ SE1->E1_PREFIXO +"-"+ SE1->E1_NUM +"-"+ SE1->E1_PARCELA + Space(60)
_cMSG := SubStr(_cMSG,1,60)
Return(_cMSG)


/*/


ͻ
Programa  VK0900Num  Autor Marcelo Brigagao     Data   03/11/10   
͹
Descricao  Retorna Numero do Titulo para impressao no boleto          
           Controle do Participante                                   
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900Num()
Local _cNum := Space(25)

_cNum := "NF Nr-"+SE1->E1_PREFIXO +"-"+ SE1->E1_NUM +"-"+ SE1->E1_PARCELA + Space(25)
_cNum := Substr(Alltrim(_cNum),1,25)

Return(_cNum)

/*/


ͻ
Programa  VK0900nBco Autor Marcelo Brigagao     Data   29/04/11   
͹
Descricao Geracao do numero bancario.                                 
ͼ


Funcao chamada atraves do execblock no arquivo de configuracao do cnab.
/*/
User Function VK0900nBco()

Local aArea			:= GetArea()
Local cSEEFilial	:= xFilial("SEE")
Local nNumBco		:= Val(AllTrim(SEE->EE_FAXATU))
Local cCodBco		:= SEE->EE_CODIGO
Local cConta		:= SEE->EE_CONTA
Local cAgencia		:= SEE->EE_AGENCIA
Local lNumera		:= IIf(SEE->EE_NUMAUT == "S",.T.,.F.)
Local cCart			:= SubStr(SEE->EE_SUBCTA,2,2)	// Para o Bco Bradesco a carteira tem apenas dois digitos, desprezamos o primeiro
Local cConv			:= Alltrim(SEE->EE_CODEMP)		// Convenio para o Bco Brasil
Local cAgItau		:= SubStr(SEE->EE_AGENCIA,1,4)	// Para calculo DAC Itau
Local cCtaItau		:= SubStr(SEE->EE_CONTA,2,5)	// Para calculo DAC Itau
Local cCartItau		:= SEE->EE_SUBCTA				// Para calculo DAC Itau

If Len(Alltrim(SA6->A6_NUMCON)) > 6 .and. cCodBco == "341"
	cCtaItau := SubStr(SA6->A6_NUMCON,1,5)
EndIf

If lNumera
	If Empty(SE1->E1_NUMBCO)
		Do Case
			Case cCodBco == "237" // Bradesco
				//			_nBase := "009"+TRIM(SE1->E1_AGEDEP)+Right(StrZero(nNumBco,10),7)
				_nBase := cCart+StrZero(nNumBco,11)
				_Mult  := "2765432765432"
				_Result:= 0
				For _nI := 13 to 1 step -1
					_Result := _Result + (val(Substr(_nBase,_nI,1))*val(Substr(_Mult,_nI,1)))
				Next
				_Dac := _Result-(int(_Result/11)*11)
				If _Dac # 0
					_Dac := 11 - _Dac
				EndIf
				If _Dac == 10
					_Dac := "P"
				Else
					_Dac := str(_Dac,1)
				EndIf

				RecLock("SE1",.F.)
				SE1->E1_NUMBCO := StrZero(nNumBco,11)+_Dac
				MsUnlock()

				nNumBco++

				dbSelectArea("SEE")
				dbSetOrder(1)
				If dbSeek(cSEEFilial+cCodBco+cAgencia+cConta)
					Reclock("SEE",.F.)
					SEE->EE_FAXATU := StrZero(nNumBco,11)
					MsUnlock()
				EndIf

			Case cCodBco == "707" // Daycoval
				_nBase := cCart+StrZero(nNumBco,11)
				_Mult  := "2765432765432"
				_Result:= 0

				For _nI := 13 to 1 step -1
					_Result := _Result + (val(Substr(_nBase,_nI,1))*val(Substr(_Mult,_nI,1)))
				Next
				_Dac := _Result-(int(_Result/11)*11)
				If _Dac # 0
					_Dac := 11 - _Dac
				EndIf
				If _Dac == 10
					_Dac := "P"
				Else
					_Dac := str(_Dac,1)
				EndIf

				RecLock("SE1",.F.)
				SE1->E1_NUMBCO := StrZero(nNumBco,12)+_Dac
				MsUnlock()

				nNumBco++

				dbSelectArea("SEE")
				dbSetOrder(1)
				If dbSeek(cSEEFilial+cCodBco+cAgencia+cConta)
					Reclock("SEE",.F.)
					SEE->EE_FAXATU := StrZero(nNumBco,11)
					MsUnlock()
				EndIf

			Case cCodBco == "001" // Banco do Brasil
				RecLock("SE1",.F.)
				SE1->E1_NUMBCO := StrZero(nNumBco,10)
				MsUnlock()

				nNumBco++

				dbSelectArea("SEE")
				dbSetOrder(1)
				If dbSeek(cSEEFilial+cCodBco+cAgencia+cConta)
					Reclock("SEE",.F.)
					SEE->EE_FAXATU := StrZero(nNumBco,10)
					MsUnlock()
				EndIf

			Case cCodBco == "341"  // Itau
				RecLock("SE1",.F.)
				SE1->E1_NUMBCO := StrZero(nNumBco,8)
				MsUnlock()

				nNumBco++

				dbSelectArea("SEE")
				dbSetOrder(1)
				If dbSeek(cSEEFilial+cCodBco+cAgencia+cConta)
					Reclock("SEE",.F.)
					SEE->EE_FAXATU := StrZero(nNumBco,8)
					MsUnlock()
				EndIf
		EndCase
	EndIf
	nNumBco := Alltrim(SE1->E1_NUMBCO)
Else
	nNumBco := Repl("0",12)
EndIf

RestArea(aArea)

Return(nNumBco)